package com.icontrole.bridge.wallpad;

import java.io.DataOutputStream;
import java.net.InetSocketAddress;
import java.net.Socket;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class MsgClientHandler{
	private Logger logger = LoggerFactory.getLogger(MsgClientHandler.class);
	
	private String clientIP;
	private int clientPort;
	
	public final int SOCKET_BUFFER_SIZE = 100;
	int SOCKET_WAIT_TIME = 3000;
	
	public MsgClientHandler (String clientIP, int clientPort) {
		this.clientIP = clientIP;
		this.clientPort = clientPort;
	} 
	
	public void doWork(String xmlStr) {
		Socket danziSocket = null;
		
		try {
			danziSocket = new Socket();
			danziSocket.setSoLinger(true, 3000);
			danziSocket.setSendBufferSize(SOCKET_BUFFER_SIZE * 1024);
			danziSocket.setSoTimeout(SOCKET_WAIT_TIME);
			
			InetSocketAddress iSocAddr = new InetSocketAddress(clientIP, clientPort);
			danziSocket.connect(iSocAddr, SOCKET_WAIT_TIME);
			
			DataOutputStream outStream = new DataOutputStream(danziSocket.getOutputStream());
			String sendMsg = xmlStr + "\r\n";
			byte[] outBF = sendMsg.getBytes("euc-kr");
			
			outStream.write(outBF);
			outStream.flush();
			
			logger.info("***************************************************");
			logger.info("   S E N D    T O " + clientPort + "  C O M P L I T E ! ! ! !  ");
			logger.info("***************************************************");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			logger.error("***************************************************");
			logger.error("   F A I L   T O "+ clientPort + "   S E N D   E V E N T   ! ! ! !  ");
			logger.error("***************************************************");
			e.printStackTrace();
		} finally {
			try {
				Thread.sleep(100);
				danziSocket.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
